//
//  AdmobSDKTestTableViewDataSource.swift
//  AdmobSDKTest
//
//  Created by Mira on 2021/6/16.
//

import UIKit

class AdmobSDKTestTableViewDataSource: NSObject, UITableViewDataSource, UITableViewDelegate {
    var didSelectBannerViewHandler: ((AdType) -> Void)?
    var didSelectInterstitialHandler: (() -> Void)?
    var didSelectNativeAdHandler: (() -> Void)?
    
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return 80
    }
    
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return AdType.numberOfRow()
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        guard let cell = tableView.dequeueReusableCell(withIdentifier: "AdmobSDKTestTableViewCell", for: indexPath) as? AdmobSDKTestTableViewCell else {
            return UITableViewCell()
        }
        cell.setItemName(with: AdType.allCases[indexPath.row].rawValue)
        return cell
    }
    
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        switch AdType.allCases[indexPath.row] {
        case .banner320X50:
            self.didSelectBannerViewHandler?(.banner320X50)
        case .banner1200x627:
            self.didSelectBannerViewHandler?(.banner1200x627)
        case .banner300x250:
            self.didSelectBannerViewHandler?(.banner300x250)
        case .interstitial:
            self.didSelectInterstitialHandler?()
        case .nativeAd:
            self.didSelectNativeAdHandler?()
        }
    }
}

enum AdType: String, CaseIterable {
    case banner320X50, banner1200x627, banner300x250, interstitial, nativeAd
    static func numberOfRow() -> Int {
        return self.allCases.count
    }
}

