//
//  ViewController.swift
//  AdmobSDKTest
//
//  Created by Mira on 2021/6/16.
//

import UIKit

class ViewController: UIViewController {

    @IBOutlet weak var admobSDKTestTableView: UITableView! {
        didSet {
            admobSDKTestTableView.delegate = tableViewDS
            admobSDKTestTableView.dataSource = tableViewDS
            admobSDKTestTableView.register(UINib(nibName: "AdmobSDKTestTableViewCell", bundle: nil), forCellReuseIdentifier: "AdmobSDKTestTableViewCell")
        }
    }
    
    private let tableViewDS = AdmobSDKTestTableViewDataSource()
    
    override func viewDidLoad() {
        super.viewDidLoad()
        self.title = "AdMob Mediation Demo"
        self.tableViewDS.didSelectBannerViewHandler = { (adType) in
            let vc = BannerViewController()
            vc.adType = adType
            self.navigationController?.pushViewController(vc, animated: true)
        }
        self.tableViewDS.didSelectInterstitialHandler = {
            let vc = InterstitialViewController()
            self.navigationController?.pushViewController(vc, animated: true)
        }
        self.tableViewDS.didSelectNativeAdHandler = {
            let vc = NativeAdViewController()
            self.navigationController?.pushViewController(vc, animated: true)
        }
    }
}

